/*
  ddless: utilities
  Steffen Plotner, 2008
*/
#include <stdarg.h>
#include <stdio.h>

#include "dd_log.h"

int log_level = 0;

void dd_loglevel_inc()
{
	log_level++;
}

void dd_log(int log_type, char *format_string, ...)
{
	va_list var_args;
	
	va_start(var_args, format_string);
	
	if ( log_type == LOG_ERR )
	{
		perror("err> perror");
		fprintf(stderr, "err> ");
		vfprintf(stderr, format_string, var_args);
		fprintf(stderr, "\n");
	}
	else
	{
		if ( log_type < log_level  )
		{
			printf("ddless> ");
			vfprintf(stdout, format_string, var_args);
			printf("\n");
		}
	}
	
	va_end(var_args);
}
